import {
    pgTable,
    bigint,
    timestamp,
    text,
    boolean,
    jsonb,
    uuid,
} from "drizzle-orm/pg-core"

import { tenants } from "./tenants"
import { customers } from "./customers"
import { authUsers } from "./auth_users"

export const customerspaces = pgTable("customerspaces", {
    id: bigint("id", { mode: "number" })
        .primaryKey()
        .generatedByDefaultAsIdentity(),

    createdAt: timestamp("created_at", { withTimezone: true })
        .notNull()
        .defaultNow(),

    name: text("name").notNull(),
    type: text("type").notNull(),

    tenant: bigint("tenant", { mode: "number" })
        .notNull()
        .references(() => tenants.id),

    customer: bigint("customer", { mode: "number" })
        .notNull()
        .references(() => customers.id),

    space_number: text("spaceNumber").notNull(),

    parentSpace: bigint("parentSpace", { mode: "number" }).references(
        () => customerspaces.id
    ),

    info_data: jsonb("infoData")
        .notNull()
        .default({ zip: "", city: "", streetNumber: "" }),

    description: text("description"),

    archived: boolean("archived").notNull().default(false),

    updatedAt: timestamp("updated_at", { withTimezone: true }),
    updatedBy: uuid("updated_by").references(() => authUsers.id),
})

export type CustomerSpace = typeof customerspaces.$inferSelect
export type NewCustomerSpace = typeof customerspaces.$inferInsert
